
local CURRENT_MODULE_NAME = ...

--cc = cc or {}

-- init base classes
cct.Event      = import(".Event")
cct.Registry   = import(".Registry")
cct.GameObject = import(".GameObject")
cct.EventProxy = import(".EventProxy")

-- init components
local components = {
    "components.behavior.StateMachine",
    "components.behavior.EventProtocol",
    "components.ui.BasicLayoutProtocol",
    "components.ui.LayoutProtocol",
}
for _, packageName in ipairs(components) do
    cct.Registry.add(import("." .. packageName, CURRENT_MODULE_NAME), packageName)
end

-- init MVC
cct.mvc = import(".mvc.init")

-- init UI library
cct.ui = import(".ui.init")
