
local ok, socket = pcall(function()
    return require("socket")
end)

if ok then
    math.randomseed(socket.gettime() * 1000)
else
    math.randomseed(os.time())
end
math.random()
math.random()
math.random()
math.random()

if type(DEBUG) ~= "number" then DEBUG = 1 end

cct = {}
cct.PACKAGE_NAME = "framework"
-- print("---|||")
-- print(cct.PACKAGE_NAME)
-- print("---|||")
cct.VERSION = "3.1.1"
cct.FRAMEWORK_NAME = "cocos2d-x ide"

require(cct.PACKAGE_NAME .. ".debug")
require(cct.PACKAGE_NAME .. ".functions")
require(cct.PACKAGE_NAME .. ".cocos2dx")

echoInfo("")
echoInfo("# DEBUG                        = "..DEBUG)
echoInfo("#")

device     = require(cct.PACKAGE_NAME .. ".device")
transition = require(cct.PACKAGE_NAME .. ".transition")
display    = require(cct.PACKAGE_NAME .. ".display")
ui         = require(cct.PACKAGE_NAME .. ".ui")
-- scheduler  = require(cct.PACKAGE_NAME .. ".scheduler")

if not NO_EXTENSIONS then
    require(cct.PACKAGE_NAME .. ".cc.init")
end

if not NO_SHORTCODES then
    require(cct.PACKAGE_NAME .. ".shortcodes")
end

-- local sharedTextureCache = CCTextureCache:getInstance()
local sharedDirector = CCDirector:getInstance()
local function showMemoryUsage()
    echoInfo(string.format("LUA VM MEMORY USED: %0.2f KB", collectgarbage("count")))
end

if DEBUG_FPS then
    sharedDirector:setDisplayStats(true)
end

if DEBUG_MEM then
    sharedDirector:getScheduler():scheduleScriptFunc(showMemoryUsage, 10.0, false)
end
